#if !defined LIB_METAL
#define LIB_METAL
    //Could make this just one function with a ton of inputs, or with a singular struct as an input.
    complexFloat AlProperties(in float wl) {
        float ev = 4.135667662e-1 * 2.99792458 / wl;
        float wp = 14.93;
        float f0 = 0.523;
        float g0 = 0.047;

        float f1 = 0.227;
        float g1 = 0.333;
        float w1 = 0.162;
        
        float f2 = 0.050;
        float g2 = 0.312;
        float w2 = 1.544;
        
        float f3 = 0.166;
        float g3 = 1.351;
        float w3 = 1.808;

        float f4 = 0.030;
        float g4 = 3.382;
        float w4 = 3.473;
        
        float omegaP = sqrt(f0) * wp;
        
        complexFloat epsilon = complexSub(
                                1.0, 
                                complexDiv(
                                    complexFloat(
                                        square(omegaP), 
                                        0.0
                                    ), 
                                    complexMul(
                                        ev, 
                                        complexAdd(
                                            ev, 
                                            complexMul(
                                                complexFloat(0.0, 1.0), 
                                                g0
                                            )
                                        )
                                    )
                                )
                            );

        float temp1 = f1 * square(wp);
        float temp2 = f2 * square(wp);
        float temp3 = f3 * square(wp);
        float temp4 = f4 * square(wp);

        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp1,
                0.0
            ),
            complexSub(
                square(w1) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g1)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp2,
                0.0
            ),
            complexSub(
                square(w2) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g2)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp3,
                0.0
            ),
            complexSub(
                square(w3) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g3)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp4,
                0.0
            ),
            complexSub(
                square(w4) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g4)
            )
        ));

        return epsilon;
    }

    complexFloat AuProperties(in float wl) {
        float ev = 4.135667662e-1 * 2.99792458 / wl;
        float wp = 9.030;
        float f0 = 0.760;
        float g0 = 0.053;

        float f1 = 0.024;
        float g1 = 0.241;
        float w1 = 0.415;
        
        float f2 = 0.010;
        float g2 = 0.345;
        float w2 = 0.830;
        
        float f3 = 0.071;
        float g3 = 0.870;
        float w3 = 2.969;

        float f4 = 0.601;
        float g4 = 2.494;
        float w4 = 4.304;

        float f5 = 4.384;
        float g5 = 2.214;
        float w5 = 13.32;
        
        float omegaP = sqrt(f0) * wp;
        
        complexFloat epsilon = complexSub(
                                1.0, 
                                complexDiv(
                                    complexFloat(
                                        square(omegaP), 
                                        0.0
                                    ), 
                                    complexMul(
                                        ev, 
                                        complexAdd(
                                            ev, 
                                            complexMul(
                                                complexFloat(0.0, 1.0), 
                                                g0
                                            )
                                        )
                                    )
                                )
                            );

        float temp1 = f1 * square(wp);
        float temp2 = f2 * square(wp);
        float temp3 = f3 * square(wp);
        float temp4 = f4 * square(wp);
        float temp5 = f5 * square(wp);

        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp1,
                0.0
            ),
            complexSub(
                square(w1) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g1)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp2,
                0.0
            ),
            complexSub(
                square(w2) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g2)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp3,
                0.0
            ),
            complexSub(
                square(w3) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g3)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp4,
                0.0
            ),
            complexSub(
                square(w4) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g4)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp5,
                0.0
            ),
            complexSub(
                square(w5) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g5)
            )
        ));

        return epsilon;
    }

    complexFloat CuProperties(in float wl) {
        float ev = 4.135667662e-1 * 2.99792458 / wl;
        float wp = 10.83;
        float f0 = 0.575;
        float g0 = 0.030;

        float f1 = 0.061;
        float g1 = 0.378;
        float w1 = 0.291;
        
        float f2 = 0.104;
        float g2 = 1.056;
        float w2 = 2.957;
        
        float f3 = 0.723;
        float g3 = 3.213;
        float w3 = 5.300;

        float f4 = 0.638;
        float g4 = 4.305;
        float w4 = 11.18;

        float omegaP = sqrt(f0) * wp;
        
        complexFloat epsilon = complexSub(
                                1.0, 
                                complexDiv(
                                    complexFloat(
                                        square(omegaP), 
                                        0.0
                                    ), 
                                    complexMul(
                                        ev, 
                                        complexAdd(
                                            ev, 
                                            complexMul(
                                                complexFloat(0.0, 1.0), 
                                                g0
                                            )
                                        )
                                    )
                                )
                            );

        float temp1 = f1 * square(wp);
        float temp2 = f2 * square(wp);
        float temp3 = f3 * square(wp);
        float temp4 = f4 * square(wp);

        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp1,
                0.0
            ),
            complexSub(
                square(w1) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g1)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp2,
                0.0
            ),
            complexSub(
                square(w2) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g2)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp3,
                0.0
            ),
            complexSub(
                square(w3) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g3)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp4,
                0.0
            ),
            complexSub(
                square(w4) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g4)
            )
        ));

        return epsilon;
    }

    complexFloat PtProperties(in float wl) {
        float ev = 4.135667662e-1 * 2.99792458 / wl;
        float wp = 9.590;
        float f0 = 0.333;
        float g0 = 0.080;

        float f1 = 0.191;
        float g1 = 0.517;
        float w1 = 0.780;
        
        float f2 = 0.659;
        float g2 = 1.838;
        float w2 = 1.314;
        
        float f3 = 0.547;
        float g3 = 3.668;
        float w3 = 3.141;

        float f4 = 3.376;
        float g4 = 8.517;
        float w4 = 9.249;
        
        float omegaP = sqrt(f0) * wp;
        
        complexFloat epsilon = complexSub(
                                1.0, 
                                complexDiv(
                                    complexFloat(
                                        square(omegaP), 
                                        0.0
                                    ), 
                                    complexMul(
                                        ev, 
                                        complexAdd(
                                            ev, 
                                            complexMul(
                                                complexFloat(0.0, 1.0), 
                                                g0
                                            )
                                        )
                                    )
                                )
                            );

        float temp1 = f1 * square(wp);
        float temp2 = f2 * square(wp);
        float temp3 = f3 * square(wp);
        float temp4 = f4 * square(wp);

        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp1,
                0.0
            ),
            complexSub(
                square(w1) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g1)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp2,
                0.0
            ),
            complexSub(
                square(w2) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g2)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp3,
                0.0
            ),
            complexSub(
                square(w3) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g3)
            )
        ));
        epsilon = complexAdd(epsilon, complexDiv(
            complexFloat(
                temp4,
                0.0
            ),
            complexSub(
                square(w4) - square(ev), 
                complexMul(complexFloat(0.0, 1.0), ev * g4)
            )
        ));

        return epsilon;
    }
#endif