#if !defined AIRY_DISK_LIB
#define AIRY_DISK_LIB
    float BesselJ(float x) {
        float integral = float(0.0);

        for(float t = 0; t < pi; t += (pi / 5.0)) {
            float dt = pi / 5.0;
            integral += cos(1 * t - x * sin(t)) * dt;
        }

        return (1.0 / pi) * integral;
    }

    float AiryDisk(float sinTheta, float k) {
        float radius = cm.apertureRadius.x;
        float airy = square((2.0 * BesselJ(k * radius * sinTheta)) / (k * radius * sinTheta));
        if(isinf(airy)) {
            airy = 0.0;
        }
        if(isnan(airy)) {
            airy = 0.0;
        }
        return airy;
    }
#endif