                vec3 oldRayDirection = rayDirection;
                vec3 rayOrigin = rayPosition;

                if(RandNextF() > throughput) {
                    throughput = 0.0;
                    break;
                }
                throughput /= saturate(throughput);

                VoxelData data;
                vec2 voxelmapCoord;
                float hitDistanceSurface;
                bool hit = RaytraceVoxel(rayPosition, hitIndex, rayDirection, rayPosition, hitIndex, hitDistanceSurface, data);

                float hitDistanceVolume;
                bool hitVolume;
                if(hit) {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, hitDistanceSurface, subsurface.sigmaT);
                } else {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, 1e35, subsurface.sigmaT);
                }

                volumeBounce = volumeBounce || hitVolume;

                if(hitVolume) {
                    //Hit a subsurface volume
                    rayPosition = rayOrigin + rayDirection * hitDistanceVolume;
                    hitIndex = ivec3(floor(rayPosition));

                    bool doScatter = RandNextF() < subsurface.albedo;

                    if(doScatter) {
                        {
                            rayDirection = Rotate(SampleSubsurfacePhase(0.85, -0.75), vec3(0.0, 0.0, 1.0), rayDirection);
                        }
                        if(pathSegment > 1) volumeBounce = true;
                    } else {
                        throughput = 0.0; //This is to ensure that it doesn't destroy performance

                        break;
                    }
                } else if(hit) {
                    //Hit the terrain
                    Material hitMaterial = hitMaterial(data, SceneSpaceFromVoxelSpace(rayPosition), wavelength);

                    mat3 tbnMatrix2 = GetRotationMatrix(data.tbnMatrix[2], data.flatNormal) * data.tbnMatrix;
                    vec3 viewDirection   = oldRayDirection * tbnMatrix2;
                         viewDirection.z = sign(dot(oldRayDirection, data.tbnMatrix[2])) * abs(viewDirection.z);

                    {
                        if(!hitMaterial.doRefract) {
                            rayPosition = hitMaterial.emissive ? rayPosition : rayPosition + data.flatNormal * 1e-5;
                            hitIndex = ivec3(floor(rayPosition));
                        }

                        ChronosPrincipledSampled(
                            viewDirection,
                            wavelength,
                            data,
                            hitMaterial,

                            rayDirection,
                            estimate,
                            throughput,
                            subsurface,
                            isRefractRay
                        );

                        if(!hitMaterial.doRefract) {
                            if (pathSegment <= MAX_PATH_SEGMENTS) {
                                if (dot(rayDirection, data.tbnMatrix[2]) <= 0.0 && data.sameMaterial) { break; }
                            }
                        }
                    }
                } else {
                    //Hit nothing
                    vec3 endColor = SrgbToLinear(vec3(75,45,130) / 255.0) * 0.02;

                    float endSpectra = 0.0;
                    RGBToSpectrum(endSpectra, wavelength, endColor.r, endColor.g, endColor.b, 0);

                    vec2 uv = rayDirection.xy;

                    if( abs(rayDirection.x) > 0.5 + (RandNextF() * 0.2))
                        uv.x = rayDirection.z;
                    else if( abs(rayDirection.y) > 0.5 + (RandNextF() * 0.2))
                        uv.y = rayDirection.z;
                    estimate += texture(noisetex, uv).r * endSpectra * throughput;

                    break;
                }