                vec3 oldRayDirection = rayDirection;
                vec3 rayOrigin = rayPosition;

                if(RandNextF() > throughput) {
                    throughput = 0.0;
                    break;
                }
                throughput /= saturate(throughput);

                VoxelData data;
                vec2 voxelmapCoord;
                float hitDistanceSurface;
                bool hit = RaytraceVoxel(rayPosition, hitIndex, rayDirection, rayPosition, hitIndex, hitDistanceSurface, data);

                float hitDistanceVolume;
                bool hitVolume;
                if(hit) {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, hitDistanceSurface, subsurface.sigmaT);
                } else {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, 1e35, subsurface.sigmaT);
                }

                /*
                float hitDistanceAir;
                bool hitVolumeAir;
                if(hit) {
                    hitVolumeAir = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceAir, hitDistanceSurface, airVolume.sigmaT);
                } else {
                    hitVolumeAir = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceAir, 1e35, airVolume.sigmaT);
                }

                {
                    vec3 netherColor = SrgbToLinear(fogColor) * 0.9 + 0.1;

                    float netherSky = 0.0;
                    RGBToSpectrum(netherSky, wavelength, netherColor.r, netherColor.g, netherColor.b, 0);

                    RandomWalkRemap(netherSky, 10.0, airVolume.sigmaT, airVolume.sigmaS);
                    airVolume.albedo = saturate(airVolume.sigmaS / airVolume.sigmaT);
                }

                volumeBounce = volumeBounce || hitVolume || hitVolumeAir;

                if(hitVolumeAir) {
                    //Hit the air volume
                    rayPosition = rayOrigin + rayDirection * hitDistanceAir;
                    hitIndex = ivec3(floor(rayPosition));

                    bool doScatter = RandNextF() < airVolume.albedo;

                    if(doScatter) {
                        {
                            rayDirection = Rotate(SampleKleinNishina(0.75), vec3(0.0, 0.0, 1.0), rayDirection);
                        }
                        if(pathSegment > 1) volumeBounce = true;
                    } else {
                        throughput = 0.0; //This is to ensure that it doesn't destroy performance

                        break;
                    }
                } else */
                if(hitVolume) {
                    //Hit a subsurface volume
                    rayPosition = rayOrigin + rayDirection * hitDistanceVolume;
                    hitIndex = ivec3(floor(rayPosition));

                    bool doScatter = RandNextF() < subsurface.albedo;

                    if(doScatter) {
                        {
                            rayDirection = Rotate(SampleSubsurfacePhase(0.85, -0.75), vec3(0.0, 0.0, 1.0), rayDirection);
                        }
                        if(pathSegment > 1) volumeBounce = true;
                    } else {
                        throughput = 0.0; //This is to ensure that it doesn't destroy performance

                        break;
                    }
                } else if(hit) {
                    //Hit the terrain
                    Material hitMaterial = hitMaterial(data, SceneSpaceFromVoxelSpace(rayPosition), wavelength);

                    mat3 tbnMatrix2 = GetRotationMatrix(data.tbnMatrix[2], data.flatNormal) * data.tbnMatrix;
                    vec3 viewDirection   = oldRayDirection * tbnMatrix2;
                         viewDirection.z = sign(dot(oldRayDirection, data.tbnMatrix[2])) * abs(viewDirection.z);

                    {
                        if(!hitMaterial.doRefract) {
                            rayPosition = hitMaterial.emissive ? rayPosition : rayPosition + data.flatNormal * 1e-5;
                            hitIndex = ivec3(floor(rayPosition));
                        }

                        ChronosPrincipledSampled(
                            viewDirection,
                            wavelength,
                            data,
                            hitMaterial,

                            rayDirection,
                            estimate,
                            throughput,
                            subsurface,
                            isRefractRay
                        );

                        if(!hitMaterial.doRefract) {
                            if (pathSegment <= MAX_PATH_SEGMENTS) {
                                if (dot(rayDirection, data.tbnMatrix[2]) <= 0.0 && data.sameMaterial) { break; }
                            }
                        }
                    }
                } else {
                    //Hit nothing
                    break;
                }