                vec3 oldRayDirection = rayDirection;
                vec3 rayOrigin = rayPosition;

                if(RandNextF() > throughput) {
                    throughput = 0.0;
                    break;
                }
                throughput /= saturate(throughput);

                VoxelData data;
                vec2 voxelmapCoord;
                float hitDistanceSurface;
                bool hit = RaytraceVoxel(rayPosition, hitIndex, rayDirection, rayPosition, hitIndex, hitDistanceSurface, data);

                vec2 aid = RSI(SceneSpaceFromVoxelSpace(rayOrigin) + vec3(0.0, planetRadius + cameraPosition.y, 0.0), rayDirection, atmosphereRadius);
                vec2 pid = RSI(SceneSpaceFromVoxelSpace(rayOrigin) + vec3(0.0, planetRadius + cameraPosition.y, 0.0), rayDirection, atmosphereLowerLimit);
                bool planetIntersected = pid.x > 0.0;
                vec3 planetNormal = normalize((SceneSpaceFromVoxelSpace(rayOrigin) + vec3(0.0, planetRadius + cameraPosition.y, 0.0)) + pid.x * rayDirection);

                float hitDistance;
                bool hitAtmosphere;
                bool hitPlanet;
                if(hit) {
                    int interaction = FindNextInteraction(rayOrigin, rayDirection, baseAttenuationCoefficients, component, hitDistance, hitDistanceSurface, wavelength);
                    hitAtmosphere = interaction == 1;
                    hitPlanet = interaction == 0;
                } else {
                    int interaction = FindNextInteraction(rayOrigin, rayDirection, baseAttenuationCoefficients, component, hitDistance, aid.y, wavelength);
                    hitAtmosphere = interaction == 1;
                    hitPlanet = interaction == 2;
                }

                float hitDistanceVolume;
                bool hitVolume;
                if(hit) {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, hitDistanceSurface, subsurface.sigmaT);
                } else {
                    hitVolume = FindNextInteractionMaterial(rayPosition, rayDirection, hitDistanceVolume, hitDistance, subsurface.sigmaT);
                }

                if(data.sameMaterial) {
                    //hitVolume = true;
                }

                volumeBounce = volumeBounce || hitAtmosphere || hitVolume;

                bool moon = RandNextF() < moonPathProbability;
                vec3 celestialRayDirection = moon ? GenerateConeVector(moonVector, RandNext2F(), moonAngularRadius) : GenerateConeVector(sunVector, RandNext2F(), sunAngularRadius);

                float irradiance = 0.0;
                if(moon) {
                    irradiance  = moonIrradiance;
                    irradiance /= moonPathProbability;
                } else {
                    irradiance  = sunIrradiance;
                    irradiance /= 1.0 - moonPathProbability;
                }

                if(hitAtmosphere) {
                    //Hit the atmosphere
                    rayPosition = rayOrigin + rayDirection * hitDistance;
                    hitIndex = ivec3(floor(rayPosition));

                    bool doScatter = false;
                    switch (component) {
                        case 0: {
                            doScatter = true;
                            break; 
                        }
                        case 1: {
                            doScatter = RandNextF() < aerosolScatteringAlbedo;
                            break; 
                        }
                        case 2: { 
                            doScatter = false; 
                            break; 
                        }
                    }

                    if(doScatter) {
                        float phase = 1.0;
                        switch (component) {
                            case 0: {
                                phase = RayleighPhaseSimple(dot(rayDirection, celestialRayDirection));
                                break;
                            }
                            case 1: {
                                phase = KleinNishina(dot(rayDirection, celestialRayDirection), 0.7);
                                break;
                            }
                            case 2: {
                                phase = 0.0;
                                break;
                            }
                        }
                        VoxelData voxelDataLight;
                        vec3 hitPositionLight = rayPosition;
                        ivec3 hitIndexLight = ivec3(hitPositionLight);
                        vec2 voxelmapCoordLight;
                        float hitDistanceSurfaceLight;
                        bool hitLight = RaytraceVoxel(hitPositionLight, hitIndexLight, celestialRayDirection, hitPositionLight, hitIndexLight, hitDistanceSurfaceLight, voxelDataLight);

                        if(!hitLight) {
                            float transmittance = EstimateTransmittance(rayPosition, celestialRayDirection, baseAttenuationCoefficients);

                            estimate += throughput * phase * irradiance * transmittance;
                        }

                        switch (component) {
                            case 0: {
                                rayDirection = Rotate(SampleRayleigh(), vec3(0.0, 0.0, 1.0), rayDirection);
                                throughput *= 1.0;
                                break; 
                            }
                            case 1: {
                                rayDirection = Rotate(SampleKleinNishina(0.7), vec3(0.0, 0.0, 1.0), rayDirection); 
                                throughput *= 1.0;
                                break; 
                            }
                            case 2: { 
                                rayDirection = oldRayDirection; 
                                break; 
                            }
                        }
                    } else {
                        throughput = 0.0; //This is to ensure that it doesn't destroy performance

                        break;
                    }
                } else if(hitVolume) {
                    //Hit a subsurface volume
                    rayPosition = rayOrigin + rayDirection * hitDistanceVolume;
                    hitIndex = ivec3(floor(rayPosition));

                    bool doScatter = RandNextF() < subsurface.albedo;

                    if(doScatter) {
                        {
                            rayDirection = Rotate(SampleSubsurfacePhase(0.85, -0.75), vec3(0.0, 0.0, 1.0), rayDirection);
                        }
                        if(pathSegment > 1) volumeBounce = true;
                    } else {
                        throughput = 0.0; //This is to ensure that it doesn't destroy performance

                        break;
                    }
                } else if(hit) {
                    //Hit the terrain
                    Material hitMaterial = hitMaterial(data, SceneSpaceFromVoxelSpace(rayPosition), wavelength);

                    mat3 tbnMatrix2 = GetRotationMatrix(data.tbnMatrix[2], data.flatNormal) * data.tbnMatrix;
                    vec3 viewDirection   = oldRayDirection * tbnMatrix2;
                         viewDirection.z = sign(dot(oldRayDirection, data.tbnMatrix[2])) * abs(viewDirection.z);

                    if(dot(data.flatNormal, celestialRayDirection) > 0.0 && !data.sameMaterial) {
                        VoxelData voxelDataLight;
                        vec3 hitPositionLight = rayPosition;
                        ivec3 hitIndexLight = ivec3(floor(hitPositionLight));
                        vec2 voxelmapCoordLight;
                        float hitDistanceSurfaceLight;
                        bool hitLight = RaytraceVoxel(hitPositionLight, hitIndexLight, celestialRayDirection, hitPositionLight, hitIndexLight, hitDistanceSurfaceLight, voxelDataLight);

                        if(!hitLight) {
                            float bsdf;

                            ChronosPrincipledEstimate(
                                viewDirection,
                                celestialRayDirection * tbnMatrix2,
                                wavelength,
                                data,
                                hitMaterial,
                                pathSegment,

                                bsdf
                            );

                            float transmittance = EstimateTransmittance(rayPosition, celestialRayDirection, baseAttenuationCoefficients);

                            estimate += throughput * bsdf * irradiance * transmittance;
                        }
                    }

                    {
                        if(!hitMaterial.doRefract) {
                            rayPosition = hitMaterial.emissive ? rayPosition : rayPosition + data.flatNormal * 1e-5;
                            hitIndex = ivec3(floor(rayPosition));
                        }

                        ChronosPrincipledSampled(
                            viewDirection,
                            wavelength,
                            data,
                            hitMaterial,

                            rayDirection,
                            estimate,
                            throughput,
                            subsurface,
                            isRefractRay
                        );

                        if(!hitMaterial.doRefract) {
                            if (pathSegment <= MAX_PATH_SEGMENTS) {
                                if (dot(rayDirection, data.tbnMatrix[2]) <= 0.0 && data.sameMaterial) { break; }
                            }
                        }
                    }
                } else if(hitPlanet) {
                    break;
                } else {
                    //Hit nothing, including the planet.
                    if(pathSegment == 0) {
                        estimate += throughput * (PhysicalSun(rayDirection, sunVector, mix(0.3, 0.7, (wavelength - 390.0) / 441.0), sunRadiance) + PhysicalMoon(rayDirection, moonVector, sunVector, moonAlbedo, earthShine, sunIrradiance));
                    }

                    break;
                }