#if !defined RNG_MSWS
#define RNG_MSWS
    uint64_t x, w1, s;

    uint msws() {
        x *= x; 
        x += (w1 += s); 
        return uint(x = (x >> 32u) | (x << 32u));
    }

    void init_msws(uint64_t seed) {
        x = 0u; w1 = 0u;
        s = (((uint64_t(1890726812u) << 32u) | seed) << 1u) | uint64_t(1u);

        msws(); msws();
    }

    #define RandNext() msws()
    #define RandNext2() uvec2(msws(), msws())
    #define RandNext3() uvec3(RandNext2(), msws())
    #define RandNext4() uvec4(RandNext3(), msws())

    #define RandNextF() (float(RandNext() & 0x00ffffffu) / float(0x00ffffff))
    #define RandNextF2() square(float(RandNext() & 0x00ffffffu) / float(0x00ffffff))
    #define RandNext2F() (vec2(RandNext2() & 0x00ffffffu) / float(0x00ffffff))
    #define RandNext3F() (vec3(RandNext3() & 0x00ffffffu) / float(0x00ffffff))
#endif