#version 450

in vec2 vaUV0;
in vec3 vaNormal;
in vec3 vaPosition;
in vec4 vaColor;

#define attribute in

attribute vec4 mc_Entity;
attribute vec2 mc_midTexCoord;
attribute vec3 at_midBlock;
attribute vec4 at_tangent;

uniform vec3 chunkOffset;

out float blockID;
out vec2 uv;
out vec2 midCoord;
out vec3 midBlock;
flat out vec3 vertexNormal;
out vec3 color;
flat out vec4 vertexTangent;

void main() {
    gl_Position = vec4(vaPosition + chunkOffset, 1.0);

    blockID = mc_Entity.x;

    uv = vaUV0;
    midCoord = mc_midTexCoord;

    midBlock = at_midBlock;
    vertexNormal = vaNormal;
    color = vaColor.rgb;

    vertexTangent = at_tangent;
}