#version 450

layout (r32ui) uniform uimage2D shadowcolorimg1;

uniform vec3 cameraPosition;

layout (local_size_x = 4, local_size_y = 4, local_size_z = 4) in;
const ivec3 workGroups = ivec3(102, 96, 102);

#include "/lib/utility/universal.glsl"
#include "/lib/voxel/voxelization.glsl"

void main() {
	uvec3 srcVoxel = gl_GlobalInvocationID;
	uvec2 srcTexel = CalculateVoxelmapIdx(srcVoxel);

	uint data = imageLoad(shadowcolorimg1, ivec2(srcTexel)).x;

	vec4 unpacked = unpackUnorm4x8(data);

	uint id = uint(255.0 * unpacked.w + 0.5);
	if (id >= (255u - OCTREE_LEVELS)) { return; }

	for (uint lod = 1u; lod < OCTREE_LEVELS; ++lod) {
		uvec3 dstVoxel = srcVoxel & (0xffffffffu << lod);
		uvec2 P = CalculateVoxelmapIdx(dstVoxel);

		id = 255u - OCTREE_LEVELS + lod;

		unpacked.w = float(id) / 255.0;
		imageAtomicMin(shadowcolorimg1, ivec2(P), packUnorm4x8(unpacked));
	}
}
