#version 450
#extension GL_ARB_gpu_shader_int64 : enable
#extension AMD_gpu_shader_int64 : enable

#define STAGE_FRAGMENT

/* DRAWBUFFERS:0 */
layout(location = 0) out vec4 outFrames;

uniform sampler2D colortex0;
uniform sampler2D colortex5;
uniform sampler2D colortex6;
uniform sampler2D colortex7;
uniform sampler2D colortex8;

uniform sampler2D shadowcolor0;
uniform sampler2D shadowcolor1;

uniform mat4 gbufferModelViewInverse, gbufferProjectionInverse;
uniform mat4 gbufferProjection, gbufferModelView;
uniform mat4 gbufferPreviousModelView, gbufferPreviousProjection;

uniform vec3 cameraPosition, previousCameraPosition;
uniform vec3 sunVector;

uniform int frameCounter;

layout(location = 0) in vec2 textureCoordinate;

#include "/lib/utility/universal.glsl"

void main() {
    bool    moved  = gbufferProjection != gbufferPreviousProjection;
    moved = moved || gbufferModelView  != gbufferPreviousModelView;
    moved = moved || cameraPosition    != previousCameraPosition;

    int frames = int(texture(colortex0, textureCoordinate).a);
    if(moved) {
        frames = 0;
    }

    outFrames.rgb = texture(colortex0, textureCoordinate).rgb;
    outFrames.a = float(frames);
}